#!/bin/sh

set -e
. ./.common.sh

rm -Rf $DAHDI $DAHDI_ORIG
tar xzf $DAHDI_ORIG.tar.gz
mv $DAHDI_ORIG $DAHDI

patch -d $DAHDIDIR/linux/include/dahdi/ < $BASEDIR/patches/kernel.h.patch
cd $DAHDIDIR/linux/drivers/dahdi/
patch < $BASEDIR/patches/dahdi-base.c.patch
patch < $BASEDIR/patches/dahdi_dynamic.c.patch
patch < $BASEDIR/patches/dahdi_dynamic_eth.c.patch
patch < $BASEDIR/patches/dahdi_dummy.c.patch

# Comment if you don't need OSLEC echo canceller
mkdir -p $DAHDIDIR/linux/drivers/staging/echo
cp -Rp $BASEDIR/oslec/. $DAHDIDIR/linux/drivers/staging/echo
sed -i "s|#ifdef CONFIG_DAHDI_MMX|#if defined (CONFIG_DAHDI_MMX) \&\& \!defined (CONFIG_X86_64)|" $DAHDIDIR/linux/drivers/dahdi/arith.h

# Uncomment to enable MMX optimization
#sed -i "s|/\* #define CONFIG_DAHDI_MMX \*/|#define CONFIG_DAHDI_MMX|" $DAHDIDIR/linux/include/dahdi/dahdi_config.h
#echo 'CFLAGS_echo.o += -DUSE_MMX' >> Kbuild
# Uncomment to enable SSE2 optimization
#sed -i "s|/\* #define CONFIG_DAHDI_MMX \*/|#define CONFIG_DAHDI_MMX|" $DAHDIDIR/linux/include/dahdi/dahdi_config.h
#echo 'CFLAGS_echo.o += -DUSE_SSE2' >> Kbuild

cd $BASEDIR
# Disable loading Digium's firmware from website (we don't need it)
sed -i "s|prereq: include/dahdi/version.h firmware-loaders|prereq: include/dahdi/version.h|" $DAHDI/linux/Makefile
sed -i "s|install-firmware install-xpp-firm|install-include|" $DAHDI/linux/Makefile
# Uncomment to enable HDLC support
#sed -i "s|/\* #define CONFIG_DAHDI_NET \*/|#define CONFIG_DAHDI_NET|" $DAHDI/linux/include/dahdi/dahdi_config.h
# Uncomment to disable tasklet in dahdi_dynamic
#sed -i "s|#define ENABLE_TASKLETS|//#define ENABLE_TASKLETS|" $DAHDI/linux/drivers/dahdi/dahdi_dynamic.c
# Uncomment to enable short flash time - 60ms. Default: 200ms.
#sed -i "s|/\* #define SHORT_FLASH_TIME \*/|#define SHORT_FLASH_TIME|" $DAHDI/linux/include/dahdi/dahdi_config.h
# Uncommend to build dahdi_dummy
sed -i "s|#obj-\$(DAHDI_BUILD_ALL)\$(CONFIG_DAHDI_DUMMY)|obj-\$(DAHDI_BUILD_ALL)\$(CONFIG_DAHDI_DUMMY)|" $DAHDI/linux/drivers/dahdi/Kbuild
# Uncomment to extend DAHDI_MAX_CHANNELS to 4096
#sed -i "s|#define DAHDI_MAX_CHANNELS		1024|#define DAHDI_MAX_CHANNELS		4096|" $DAHDI/linux/include/dahdi/user.h
# Put any additional patches/commands here.
#editor $DAHDI/linux/include/dahdi/dahdi_config.h

cd $DAHDIDIR/linux
make $MAKEOPS

cd $BASEDIR
rm -rf quasar quasarm quasar-$QUASAR_VER  quasarm-$QUASARM_VER
tar xfj quasar-$QUASAR_VER.tar.bz2

mv quasar-$QUASAR_VER quasar
make -C quasar $MAKEOPS $MODULEOPS

rm -rf dahdi_tdmox
tar xfj dahdi_tdmox.tar.bz2
make -C dahdi_tdmox $MAKEOPS $MODULEOPS


echo "#################################################################"
echo "### You have built modules."
echo "### "
echo "### You can install them with ./install.sh ."
echo "### Make sure you have removed DAHDI modules from /lib/modules/`uname -r` ."
echo "### You can also test modules before installing."
echo "### See parabel directory for samples."
echo "#################################################################"
